
;;;;-----------------------------------Hauptprogramm---------------------------------------------------------

(defun C:Attdreh (/ MDIALOG OK hoe atthoe md_neu_atthoe brei md_neu_attbrei attbrei wink md_neu_attwink attwink true)

  (setq md_err  *error*
        *error* Fehler
        ) ;_ end of setq
  (command "_UNDO" "_MARK")

  (md_setvar)
;;;Systemvariablen stellen

  (setq MDIALOG (load_dialog "ATTHOE.DCL"))
  (if (not (new_dialog "atthoe" MDIALOG))
    (progn
      (alert "Dialogsteuerungsdatei Atthoe.DCL nicht gefunden. \nAbbruch!")
      (exit)
    );ende Progn
  ) ;_ end of if
  (action_tile "hoe" "(setq hoe (atoi $value))")
  (action_tile "atthoe" "(setq atthoe  $value)")
  (action_tile "brei" "(setq brei (atoi $value))")
  (action_tile "attbrei" "(setq attbrei (atoi $value))")
  (action_tile "wink" "(setq wink (atoi $value))")
  (action_tile "attwink" "(setq attwink (atoi $value))")
  (action_tile "cancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")
  (setq OK (start_dialog))
  (unload_dialog MDIALOG)
;;;Aufruf der Prfprogramme
  (if OK
    (progn
      (if (and (= 1 hoe)(/= atthoe nil))
        (setq md_neu_atthoe (atof atthoe))
        )
      (if (and (= 1 brei)(/= attbrei nil))
        (setq md_neu_attbrei (float attbrei))
        )
      (if (and (= 1 wink)(/= attwink nil))
        (setq md_neu_attwink (itoa attwink))
        )
      (if
        (or (/= md_neu_atthoe nil)(/= md_neu_attbrei nil)(/= md_neu_attwink nil))
        (setq true t)
        )
      )
    )
  (md_attdreh)
  ;;Unterprogramm zur umsetzung der Trattribute

  (princ "\nFertig")
  (princ)

  )                                     ;ende defun


 ;---------------------------Systemvariablen setzen-------------------------------------
(defun md_setvar (/)
  (setq md_cmddia    (getvar "cmddia")
        md_cmdecho   (getvar "cmdecho")
        md_filedia   (getvar "filedia")
        md_osmode    (getvar "osmode")
        md_orthomode (getvar "orthomode")
        md_attreq    (getvar "attreq")
        true nil
        OK nil
        hoe nil
        atthoe nil
        md_neu_atthoe nil
        brei nil
        attbrei nil
        md_neu_attbrei nil
        wink nil
        attwink nil
        md_neu_attwink nil
        ) ;_ end of setq
  (setvar "cmdecho" 0)
                                        ;(setvar "cmddia" 0)
                                        ;(setvar "filedia" 0)
  (setvar "osmode" 0)
  (setvar "orthomode" 0)
  (setvar "attreq" 0)
  )                                     ;ende defun

 ;----------------------------Variablen zurckstellen-------------------------------
(defun md_reset (/)
  (setvar "cmdecho" md_cmdecho)
                                        ;(setvar "cmddia" md_cmddia)
                                        ;(setvar "filedia" md_filedia)
  (setvar "osmode" md_osmode)
  (setvar "orthomode" md_orthomode)
  (setvar "attreq" md_attreq)
  )                                     ;ende defun

 ;----------------------------Fehlerbehandlung--------------------------------------
(defun Fehler (s)
  (print (strcat "Fehler " s))
  (command)
  (command "_UNDO" "_BACK")
  (setq *error* md_err)
  (princ)
  ) ;_ end of defun

 ;-------------------------Filterliste erstellen
(defun md_filterliste (/ as_filter)
  (if true
    (progn
  (prompt
    "Block whlen, dessen Attribute gendert werden sollen."
    ) ;_ end of prompt
  (setq as_filter (entget (car (entsel))))
  (if (= (cdr (assoc 0 as_filter)) "INSERT")
    (progn
      (cond
        ((or (= (cdr (assoc 66 as_filter)) 0)
             (= (assoc 66 as_filter) nil)
             ) ;_ end of or
         (alert "der Block hat keine Attribute!")
         )
        ((= (cdr (assoc 66 as_filter)) 1)
         (setq
           md_fl (ssget "X"
                        (list (cons 0 "INSERT") (assoc 2 as_filter))
                        ) ;_ end of ssget
           ) ;_ end of setq
         )
        ) ;_ end of cond
      ) ;_ end of progn
    (alert "Das war kein Block!")
    ) ;_ end of if
  )
    )
  )                                     ;ende defun

;;;-----------------Attribute der Trblcke ausrichten----------------------------------
(defun md_0 (aslst / md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while
    (/= (cdr (assoc 0 aslst)) "SEQEND")
     (if
       (= (cdr (assoc 0 aslst)) "ATTRIB")
        (progn
;;;          (if
;;;           (/= (setq md_txh (cdr (assoc 40 aslst))) 0.12)
          (setq
            aslst (subst (cons 40 md_neu_atthoe) (assoc 40 aslst) aslst)
            ) ;_ end of setq
;;;           );ende if
          (entmod aslst)
          )                             ;ende progn
        )                               ;if
     (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
     )                                  ;ende while
  )                                     ;ende defun

(defun md_90 (aslst / md_attwink attin attal attnx md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while (/= (cdr (assoc 0 aslst)) "SEQEND")
    (if (= (cdr (assoc 0 aslst)) "ATTRIB")
      (progn
        (setq md_attwink (angtos (cdr (assoc 50 aslst)) 0 0))
        (if
          (= md_attwink "180")
           (progn
             (setq attin (assoc 11 aslst)
                   attal (nth 1 attin)
                   attnx (list 11 (- (nth 1 attin) 1.1) (nth 2 attin) 0.0)
                   aslst (subst attnx attin aslst)
                   aslst (subst (cons 50 0.0) (assoc 50 aslst) aslst)
                   ) ;_ end of setq
;;;             (if
;;;               (/= (setq md_txh (cdr (assoc 40 aslst))) 0.12)
             (setq aslst (subst (cons 40 md_neu_atthoe)
                                (assoc 40 aslst)
                                aslst
                                ) ;_ end of subst
                   ) ;_ end of setq
;;;              );ende if
             (entmod aslst)
             )                          ;ende progn
           )                            ;ende if
        )                               ;ende progn
      )                                 ;if
    (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
    )                                   ;ende while
  )                                     ;ende defun

(defun md_180 (aslst / md_attwink attin attal attnx md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while (/= (cdr (assoc 0 aslst)) "SEQEND")
    (if (= (cdr (assoc 0 aslst)) "ATTRIB")
      (progn
        (setq md_attwink (angtos (cdr (assoc 50 aslst)) 0 0))
        (if
          (= md_attwink "270")
           (progn
             (setq attin (assoc 11 aslst)
                   attal (nth 2 attin)
                   attnx (list 11 (nth 1 attin) (- (nth 2 attin) 1.1) 0.0)
                   aslst (subst attnx attin aslst)
                   aslst (subst (cons 50 (angtof "90" 0))
                                (assoc 50 aslst)
                                aslst
                                ) ;_ end of subst
                   ) ;_ end of setq
;;;             (if
;;;               (/= (setq md_txh (cdr (assoc 40 aslst))) 0.12)
             (setq aslst (subst (cons 40 md_neu_atthoe)
                                (assoc 40 aslst)
                                aslst
                                ) ;_ end of subst
                   ) ;_ end of setq
;;;              );ende if
             (entmod aslst)
             )                          ;ende progn
           )                            ;ende if
        )                               ;ende progn
      )                                 ;if
    (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
    )                                   ;ende while
  )                                     ;ende defun


(defun md_270 (aslst / md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while
    (/= (cdr (assoc 0 aslst)) "SEQEND")
     (if
       (= (cdr (assoc 0 aslst)) "ATTRIB")
        (progn
;;;          (if
;;;           (/= (setq md_txh (cdr (assoc 40 aslst))) 0.12)
          (setq
            aslst (subst (cons 40 md_neu_atthoe) (assoc 40 aslst) aslst)
            ) ;_ end of setq
;;;           );ende if
          (entmod aslst)
          )                             ;ende progn
        )                               ;if
     (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
     )                                  ;ende while
  )                                     ;ende defun

(defun md_sonst (aslst / md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while
    (/= (cdr (assoc 0 aslst)) "SEQEND")
     (if
       (= (cdr (assoc 0 aslst)) "ATTRIB")
        (progn
          (setq attin (assoc 11 aslst)
                attal (nth 2 attin)
                attnx (list 11 (nth 1 attin) (nth 2 attin) 0.0)
                aslst (subst attnx attin aslst)
                ) ;_ end of setq
          (if md_neu_atthoe
            (setq
              aslst
               (subst (cons 40 md_neu_atthoe) (assoc 40 aslst) aslst)
              ) ;_ end of setq
            ) ;_ end of if
          (if md_neu_attbrei
            (setq
              aslst (subst (cons 41 md_neu_attbrei)
                           (assoc 41 aslst)
                           aslst
                           ) ;_ end of subst
              ) ;_ end of setq
            (if md_neu_attwink
              (setq
                aslst (subst (cons 50 (angtof md_neu_attwink 0))
                             (assoc 50 aslst)
                             aslst
                             ) ;_ end of subst
                ) ;_ end of setq
              ) ;_ end of if
            ) ;_ end of if
          (entmod aslst)
          )                             ;ende progn
        )                               ;if
     (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
     )                                  ;ende while
  )                                     ;ende defun

;;;-----------------------Programmausfhrung--------------------------------------
(defun md_arbeit (md_fl / md_zaehler md_nenner info aslst md_einfwink)
  ;(setq md_neu_atthoe (getreal "\nNeue Attrubutshhe: "))
  (setq md_zaehler 0)
  (setq md_nenner (sslength md_fl))
  (while (> md_nenner md_zaehler)
    (progn
      (setq info (ssname md_fl md_zaehler))
      (setq aslst (entget info))
      (setq md_einfwink (angtos (cdr (assoc 50 aslst)) 0 0))

;;;je nach welchem Drehwinkel die Tr eingefgt ist werden die Attribute gedreht
      (cond
;;;        ((= md_einfwink "0") (md_0 aslst))
;;;        ((= md_einfwink "90") (md_90 aslst))
;;;        ((= md_einfwink "180") (md_180 aslst))
;;;        ((= md_einfwink "270") (md_270 aslst))
        (T (md_sonst aslst))
        )                               ;ende cond
      )                                 ;ende progn
    (setq md_zaehler (1+ md_zaehler))
    )                                   ;ende while
  )                                     ;ende defun

;;;;;;;;;;;;;;;;;;;;;;;;;Attribute drehen / Schrifthhe gleichsetzen

(defun md_attdreh (/ md_fl)

  (md_filterliste)
  ;;eine Objektauswahl von allen zu bearbeitenden Blcken erstellen
  (if md_fl
  (md_arbeit md_fl)
    )
;;;Hauptprogrammausfhrung

  (command "regen")
  (md_reset)
;;;Variablen zurckstellen
  (setq *error* md_err)
  (princ)
  )                                     ;ende defun
(prompt "\nStarten mit 'Attdreh'")
;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
